#Module-Specific definitions
%define mod_version 0.6
%define release 1mdk
%define mod_name mod_webfilter
%define mod_conf A12_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename %{mod_name}-%{mod_version}

#New ADVX macros
%define ADVXdir %{_datadir}/ADVX
%{expand:%(cat %{ADVXdir}/ADVX-build)}
%{expand:%%global ap_version %(%{apxs} -q ap_version)}

# Standard Module Definitions
%define name %{ap_name}-%{mod_name}
%define version %{ap_version}_%{mod_version}

#Standard ADVX requires
Prereq:		%{ap_name} = %{ap_version}
Prereq:		%{ap_name}-conf
BuildPreReq:	ADVX-build >= 9.2
BuildRequires:	%{ap_name}-devel >= 2.0.43-5mdk
Provides: 	ADVXpackage
Provides:	AP20package

Summary:	An %{ap_name} content filter module
Name:		%{name}
Version:	%{version}
Release:	%{release}
Group:		System/Servers
Source0:	%{sourcename}.tar.bz2
Source1:	%{mod_conf}.bz2
Source2:	mod_webfilter.txt.bz2
Patch0:		mod_webfilter-0.6-misc_fixes.patch.bz2
License:	GPL
URL:		http://software.othello.ch/mod_webfilter/
#BuildRequires:	libgdbm-devel (required by apache2-devel)
#Requires:	libgdbm2 (required by apache2)
Requires:	%{ap_name}-mod_php
Requires:	%{ap_name}-mod_proxy
Prereq:		rpm-helper
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
Even though the free software community opposes censoring efforts
on the Internet, corporations still prefer to restrict the access
their employees have to the interet with technical measures.
Flexible solutions for URL filtering have so far mostly been
provided by commercial software vendors, free software
implementations usually were not versatile enough for commercial
environments. Unfortunately, this also meant that commercial
products were used for proxies and firewalls, and in the process
for many other things as well. 


We believe that mod_webfilter could improve this. In the webfilter
databases, each hostname or domain suffix is categorized with one
or more categories describing the content the site offers. The
administrator can configure the module with a whitelist and a
blacklist. If the hostname requested by a user has a category as
specified in the whitelist, the request is accepted, even if the
following blacklist test would reject it. If the hostname
requested has a category as specified in the black list, it is
rejected. All other requests are accepted, but tag filtering, an
additional capability of the module, is applied to the content
delivered for this URL. 


In principle, one database for blacklist and whitelist would be
enough, nevertheless the module allows the databases for whitelist
and blacklist to be different. This makes sense e.g. in a setting
where the blacklist is imported from some public database of
`indecent' URLs, and the whitelist is a locally maintained
database of exceptions. 

%prep

%setup -q -n %{sourcename}
%patch0 -p1

bzcat %{SOURCE2} > mod_webfilter.txt

%build
export WANT_AUTOCONF_2_5=1

libtoolize --copy --force; aclocal; autoconf; automake

export CFLAGS=`%{apxs} -q CFLAGS`

%configure2_5x \
    --with-apxs=%{apxs} \
    --with-htdocs=/var/www/html/admin/mod_webfilter

make

pushd module
    # the autoconf stuff is a mess, we have to build the module "by hand"
    echo "static char *mod_webfilter_version = \"%{mod_version}\";" > mod_webfilter_version.h
    %{apxs} -c mod_webfilter.c
    mv .libs ../
popd

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%makeinstall_std

install -d %{buildroot}/var/www/html/admin/%{mod_name}
install -d %{buildroot}/var/lib/%{mod_name}

# create some funny defaults ;)
echo "bad_sites no_visit" | %{buildroot}%{_bindir}/webfilter_create \
    %{buildroot}/var/lib/mod_webfilter/blacktypes

echo "good_sites go_visit" | %{buildroot}%{_bindir}/webfilter_create \
    %{buildroot}/var/lib/mod_webfilter/whitetypes

echo "www.microsoft.com bad_sites #bad" | %{buildroot}%{_bindir}/webfilter_create \
    %{buildroot}/var/lib/mod_webfilter/black

echo "www.deserve-it.com good_sites #good" | %{buildroot}%{_bindir}/webfilter_create \
    %{buildroot}/var/lib/mod_webfilter/white

# remove silly things...
rm -f %{buildroot}/var/www/html/admin/mod_webfilter/*

# install the web stuff
install -m644 web/whitelist.php %{buildroot}/var/www/html/admin/mod_webfilter/whitelist.php

%ADVXinstlib
%ADVXinstconf %{SOURCE1} %{mod_conf}
%ADVXinstdoc %{name}-%{version}

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%post
%ADVXpost

%postun
%ADVXpost

%files
%defattr(-,root,root)
%doc doc/mod_webfilter.html AUTHORS ChangeLog NEWS README TODO mod_webfilter.txt
%attr(0755,apache,apache) %dir /var/lib/mod_webfilter
%config(noreplace) %attr(0666,apache,apache) /var/lib/mod_webfilter/white
%config(noreplace) %attr(0666,apache,apache) /var/lib/mod_webfilter/black
%config(noreplace) %attr(0666,apache,apache) /var/lib/mod_webfilter/whitetypes
%config(noreplace) %attr(0666,apache,apache) /var/lib/mod_webfilter/blacktypes
%config(noreplace) %{ap_confd}/%{mod_conf}
%{_bindir}/webfilter_*
%{ap_extralibs}/%{mod_so}
%{ap_webdoc}/*
%attr(0644,root,root) /var/www/html/admin/mod_webfilter/whitelist.php
%{_mandir}/man1/webfilter_*

%changelog
* Sat Aug 30 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_0.6-1mdk
- the actual upload...
- added S2

* Mon Jun 30 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_0.6-1mdk
- initial cooker contrib

* Tue Jun 24 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_0.5-1mdk
- initial cooker contrib
